package com.huimv.farm.damsubsidy.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.farm.damsubsidy.common.token.TokenSign;
import com.huimv.farm.damsubsidy.common.utils.BuyImageUtil;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.common.utils.UploadImage;
import com.huimv.farm.damsubsidy.entity.*;
import com.huimv.farm.damsubsidy.entity.vo.BillBuyInfoVo;
import com.huimv.farm.damsubsidy.entity.BillLandingInspection;
import com.huimv.farm.damsubsidy.mapper.BaseAnimalMapper;
import com.huimv.farm.damsubsidy.mapper.BillBuyInfoMapper;
import com.huimv.farm.damsubsidy.mapper.BillLandingInspectionMapper;
import com.huimv.farm.damsubsidy.mapper.SysUserMapper;
import com.huimv.farm.damsubsidy.service.IBillBuyInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 交易信息 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-04-26
 */
@Service
public class BillBuyInfoServiceImpl extends ServiceImpl<BillBuyInfoMapper, BillBuyInfo> implements IBillBuyInfoService {
    @Resource
    private BaseAnimalMapper baseAnimalMapper;
    @Resource
    private BillBuyInfoMapper billBuyInfoMapper;
    @Resource
    private SysUserMapper sysUserMapper;
    @Resource
    private BillLandingInspectionMapper billLandingInspectionMapper;
    @Autowired
    private UploadImage uploadImage;
    @Override
    @Transactional(rollbackFor = RuntimeException.class)
    public synchronized Result addTransaction(HttpServletRequest httpServletRequest, MultipartFile buyImage1, MultipartFile buyImage2, MultipartFile buyImage3, MultipartFile buyImage4, MultipartFile buyImage5, MultipartFile image2, MultipartFile image3, String inspectionNum, String seller, String buyer, String num, String eartags,String buyerPhone) throws IOException {
        BillBuyInfo billBuyInfo1 = billBuyInfoMapper.selectOne(new QueryWrapper<BillBuyInfo>().eq("create_user", TokenSign.getMemberIdByJwtToken(httpServletRequest)).eq("bill_buy_status",1));
        SysUser sysUser = sysUserMapper.selectOne(new QueryWrapper<SysUser>().eq("phone", buyerPhone));
        BillLandingInspection billLandingInspection = billLandingInspectionMapper.selectOne(new QueryWrapper<BillLandingInspection>().eq("inspection_num", inspectionNum));
        int total = Integer.parseInt(num);
        String content = null;
        if (ObjectUtil.isNotEmpty(sysUser)){
            if (!sysUser.getUserName().equals(buyer)){
                return new Result(10001,"买家手机号和姓名不匹配",false);
            }
        }
        String[] eartag = eartags.split(",");
       if (eartag.length != total){
           return new Result(10001,"交易数量与实际耳标号数量不符!",false);
       }
        for (String eartagNo : eartag) {
            BaseAnimal baseAnimal = baseAnimalMapper.selectOne(new QueryWrapper<BaseAnimal>().eq("earatg_no", eartagNo));
            if (ObjectUtil.isEmpty(sysUser)){
                SysUser newUser = new SysUser();
                newUser.setUserName(buyer);
                newUser.setPhone(buyerPhone);
                newUser.setUserType(3);
                newUser.setAccoutType(1);
                newUser.setCreateTime(DateTime.now());
                newUser.setCreateUser(TokenSign.getMemberIdByJwtToken(httpServletRequest));
                newUser.setIsRealName(0);
                sysUserMapper.insert(newUser);
                baseAnimal.setBelongToUser(newUser.getId());
            }else {
                baseAnimal.setBelongToUser(sysUser.getId());
            }
            baseAnimal.setBuyerName(buyer);
            baseAnimal.setSellerName(seller);
            baseAnimal.setAnimalStatus(2);
            baseAnimal.setBuyTime(DateTime.now());
            baseAnimalMapper.updateById(baseAnimal);
        }
        content = BuyImageUtil.getUrl(content,buyImage1);
        content = BuyImageUtil.getUrl(content,buyImage2);
        content = BuyImageUtil.getUrl(content,buyImage3);
        content = BuyImageUtil.getUrl(content,buyImage4);
        content = BuyImageUtil.getUrl(content,buyImage5);
        String content2 = uploadImage.getImageCom(image2);
        String content3 = uploadImage.getImageCom(image3);


        if (ObjectUtil.isEmpty(billBuyInfo1)){
            BillBuyInfo billBuyInfo = new BillBuyInfo();
            billBuyInfo.setBuyName(seller+"和"+buyer+"的交易信息");
            billBuyInfo.setInspectionNum(inspectionNum);
            billBuyInfo.setBuyerName(buyer);
            billBuyInfo.setSellerName(seller);
            billBuyInfo.setBuyerPhone(buyerPhone);
            billBuyInfo.setCreateUser(TokenSign.getMemberIdByJwtToken(httpServletRequest));
            billBuyInfo.setCreateTime(DateTime.now());
            billBuyInfo.setRealNumUp(num);
            billBuyInfo.setBuyPicUrl(content);
            billBuyInfo.setSellerId(billLandingInspection.getCreateUser());
            billBuyInfo.setPayPicUrl(content2);
            billBuyInfo.setBuyPayGoodsPicUrl(content3);
            billBuyInfo.setRealEartag(eartags);
            billBuyInfo.setBillBuyStatus(2);
            this.save(billBuyInfo);
        }else {
            billBuyInfo1.setBuyName(seller+"和"+buyer+"的交易信息");
            billBuyInfo1.setInspectionNum(inspectionNum);
            billBuyInfo1.setBuyerName(buyer);
            billBuyInfo1.setSellerName(seller);
            billBuyInfo1.setBuyerPhone(buyerPhone);
            billBuyInfo1.setCreateUser(TokenSign.getMemberIdByJwtToken(httpServletRequest));
            billBuyInfo1.setSellerId(billLandingInspection.getCreateUser());
            billBuyInfo1.setCreateTime(DateTime.now());
            billBuyInfo1.setRealNumUp(num);
            billBuyInfo1.setBuyPicUrl(content);
            billBuyInfo1.setPayPicUrl(content2);
            billBuyInfo1.setBuyPayGoodsPicUrl(content3);
            billBuyInfo1.setRealEartag(eartags);
            billBuyInfo1.setBillBuyStatus(2);
            this.updateById(billBuyInfo1);
        }
        if(ObjectUtil.isEmpty(sysUser)){
            return new Result(10003,"交易成功买家用户信息不存在,已新建账号",true);
        }
        return Result.SUCCESS();
    }

    @Override
    @Transactional
    public Result saveTransaction(HttpServletRequest httpServletRequest,Map<String, String> paramsMap) {
        String inspectionNum = paramsMap.get("inspectionNum");
        String seller = paramsMap.get("seller");
        String buyer = paramsMap.get("buyer");
        String num = paramsMap.get("num");
        String eartags = paramsMap.get("eartags");
        String buyerPhone = paramsMap.get("buyerPhone");
//        String imgname = "成功";
//        String originalFilename = image1.getOriginalFilename();
//        String filenameExtension = StringUtils.getFilenameExtension(originalFilename);
//        String path = DateUtil.format(new Date(),"yyyy-MM");
//        try {
//            InputStream inputStream = image1.getInputStream();
//            BufferedInputStream in = new BufferedInputStream(inputStream);
//            ByteArrayOutputStream out = new ByteArrayOutputStream(1024);
//
//            byte[] temp = new byte[1024];
//            int size = 0;
//            while ((size = in.read(temp)) != -1) {
//                out.write(temp, 0, size);
//            }
//            in.close();
//            byte[] content = out.toByteArray();
//            imgname = UUID.randomUUID()+"."+filenameExtension;
//            UploadImage.sshSftp(content,path, imgname);
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//        String content = "https://dam.img.ifarmcloud.com:8030/images/"+path +"/"+imgname;
//
//        String imgname2 = "成功";
//        String originalFilename2 = image2.getOriginalFilename();
//        String filenameExtension2 = StringUtils.getFilenameExtension(originalFilename2);
//        String path2 = DateUtil.format(new Date(),"yyyy-MM");
//        try {
//            InputStream inputStream = image2.getInputStream();
//            BufferedInputStream in = new BufferedInputStream(inputStream);
//            ByteArrayOutputStream out = new ByteArrayOutputStream(1024);
//
//            byte[] temp = new byte[1024];
//            int size = 0;
//            while ((size = in.read(temp)) != -1) {
//                out.write(temp, 0, size);
//            }
//            in.close();
//            byte[] content2 = out.toByteArray();
//            imgname2 = UUID.randomUUID()+"."+filenameExtension2;
//            UploadImage.sshSftp(content2,path2, imgname2);
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//        String content2 = "https://dam.img.ifarmcloud.com:8030/images/"+path2 +"/"+imgname2;
//
//        String imgname3 = "成功";
//        String originalFilename3 = image3.getOriginalFilename();
//        String filenameExtension3 = StringUtils.getFilenameExtension(originalFilename3);
//        String path3 = DateUtil.format(new Date(),"yyyy-MM");
//        try {
//            InputStream inputStream = image3.getInputStream();
//            BufferedInputStream in = new BufferedInputStream(inputStream);
//            ByteArrayOutputStream out = new ByteArrayOutputStream(1024);
//
//            byte[] temp = new byte[1024];
//            int size = 0;
//            while ((size = in.read(temp)) != -1) {
//                out.write(temp, 0, size);
//            }
//            in.close();
//            byte[] content3 = out.toByteArray();
//            imgname3 = UUID.randomUUID()+"."+filenameExtension3;
//            UploadImage.sshSftp(content3,path3, imgname3);
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//        String content3 = "https://dam.img.ifarmcloud.com:8030/images/"+path3 +"/"+imgname3;

        BillBuyInfo billBuyInfo1 = billBuyInfoMapper.selectOne(new QueryWrapper<BillBuyInfo>().eq("create_user", TokenSign.getUserName(httpServletRequest)).eq("bill_buy_status",1));
        if (ObjectUtil.isEmpty(billBuyInfo1)){
            BillBuyInfo billBuyInfo = new BillBuyInfo();
            billBuyInfo.setBuyName(seller+"和"+buyer+"的交易信息");
            billBuyInfo.setInspectionNum(inspectionNum);
            billBuyInfo.setBuyerName(buyer);
            billBuyInfo1.setBuyerPhone(buyerPhone);
            billBuyInfo.setSellerName(seller);
            billBuyInfo.setCreateUser(TokenSign.getMemberIdByJwtToken(httpServletRequest));
            billBuyInfo.setCreateTime(DateTime.now());
            billBuyInfo.setRealNumUp(num);
//            billBuyInfo.setBuyPicUrl(content);
//            billBuyInfo.setPayPicUrl(content2);
//            billBuyInfo.setBuyPayGoodsPicUrl(content3);
            billBuyInfo.setRealEartag(eartags);
            billBuyInfo.setBillBuyStatus(1);
            this.save(billBuyInfo);
        }else {
            billBuyInfo1.setBuyName(seller+"和"+buyer+"的交易信息");
            billBuyInfo1.setInspectionNum(inspectionNum);
            billBuyInfo1.setBuyerName(buyer);
            billBuyInfo1.setBuyerPhone(buyerPhone);
            billBuyInfo1.setSellerName(seller);
            billBuyInfo1.setCreateUser(TokenSign.getMemberIdByJwtToken(httpServletRequest));
            billBuyInfo1.setCreateTime(DateTime.now());
            billBuyInfo1.setRealNumUp(num);
//            billBuyInfo1.setBuyPicUrl(content);
//            billBuyInfo1.setPayPicUrl(content2);
//            billBuyInfo1.setBuyPayGoodsPicUrl(content3);
            billBuyInfo1.setRealEartag(eartags);
            billBuyInfo1.setBillBuyStatus(1);
            this.updateById(billBuyInfo1);
        }
        return Result.SUCCESS();
    }

    @Override
    public Result getLast(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        BillBuyInfoVo billBuyInfo = billBuyInfoMapper.getLast(TokenSign.getMemberIdByJwtToken(httpServletRequest));
        if (ObjectUtil.isEmpty(billBuyInfo)){
            return new Result(ResultCode.SUCCESS,null);
        }else {
            return new Result(ResultCode.SUCCESS,billBuyInfo);
        }
    }

    @Override
    public Result listDetail(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        BillBuyInfoVo billBuyInfo= billBuyInfoMapper.listDetail(id);
        return new Result(ResultCode.SUCCESS,billBuyInfo);
    }
}
